<template>
  <div class="bg-[#fff]">
    <a-page-header style="border: 1px solid rgb(235, 237, 240)" @back="router.go(-1)">
      <template #backIcon>
        <div><a-button type="primary">返回</a-button></div>
      </template>
      <template #title>
        <div></div>
      </template>
    </a-page-header>
    <a-collapse v-model:activeKey="activeKey" :bordered="false">
      <a-collapse-panel key="1" header="地块信息" :forceRender="true">
        <DkTable :data="dsInfor.wrdkjbxxb" />
      </a-collapse-panel>

      <a-collapse-panel key="2" header="风险管控方案基本信息" :forceRender="true">
        <suBainForm ref="chilrenReport" :data="dsInfor.gkxf" />
        <template #extra><a-button type="primary" @click.prevent="saveReport($event)">保存</a-button></template>
      </a-collapse-panel>

      <a-collapse-panel header="风险管控方案编制单位基本信息" :forceRender="true" v-for="(item, index) in unitMessageFormList" :key="index + 4">
        <unitMessageForm :ref="(el) => childRef(el, index)" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addUnitMessageFormList($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="delMessageFormList($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="suBainFormAddEdit($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel header="风险管控方案实施单位基本信息" :forceRender="true" v-for="(item, index) in ssdw" :key="index + 9">
        <unitMessageForm :ref="(el) => childRefss(el, index)" :data="item" />
        <template #extra>
          <a-button type="primary" @click.prevent="addSs($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="deless($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="savess($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel
        header="风险管控方案监理单位基本信息"
        :forceRender="true"
        v-for="(item, index) in jldw"
        :key="index + 12"
        :dkxx="{ wrdkid: dsInfor.wrdkjbxxb.wrdkid, scjdbm: 'S5' }"
      >
        <unitMessageForm :ref="(el) => childRefjl(el, index)" :data="item" upload="检测单位" title="监理" />
        <template #extra>
          <a-button type="primary" @click.prevent="addjl($event)">添加</a-button>
          <a-button type="primary" class="ml-5" v-if="index != 0" @click.prevent="deljl($event, index)">删除</a-button>
          <a-button type="primary" @click.prevent="savejl($event, index)" style="margin-left: 10px">保存</a-button>
        </template>
      </a-collapse-panel>
      <a-collapse-panel key="4222222" header="土壤和地下水风险管控信息">
          <EditTrwrDetail  :data="dsInfor.trhjfxxx" />
      </a-collapse-panel>
      <a-collapse-panel header="风险管控措施信息" :forceRender="true" key="140000">
        <ControlInformation ref="chilrenReportxx" :data="dsInfor.gkxf" />
        <template #extra><a-button type="primary" @click.prevent="saveCsxx($event)">保存</a-button></template>
      </a-collapse-panel>
      <a-collapse-panel header="风险管控文件上传" :forceRender="true" key="150000">
        <CdUpload
          labelFirst="风险管控"
          :dkxx="dsInfor.wrdkjbxxb"
          :objec="[{ name: '公示截图' }, { name: '风险管控方案' }]"
          :data="{ ...dsInfor.gkxf, scjdbm: 'S4', pgtype: params.pgtype }"
          @upsuccess="handleUpSuccess"
        />
      </a-collapse-panel>
      <a-collapse-panel header="填报进度" :forceRender="true" key="160000">
        <fillProgress :List="dsInfor.lzjd"></fillProgress>
      </a-collapse-panel>
    </a-collapse>
  </div>
</template>
<script lang="ts" setup>
  import { ref } from 'vue';
  import DkTable from '/@/components/customComponent/DkTable.vue';
  import suBainForm from '/@/components/customComponent/fxgk/ControlPlan.vue';
  import ControlInformation from '/@/components/customComponent/fxgk/ControlInformation.vue';
  import EditTrwrDetail from '/@/components/customComponent/fxpg/trfxDetail.vue'; //土壤和地下水风险管控信息
  import unitMessageForm from '/@/components/customComponent/unitMessageForm.vue';
  import fillProgress from '/@/components/customComponent/fillProgress.vue';
  import CdUpload from '/@/components/customComponent/CdUpload.vue';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { plotDetails, updateBzdw, delBzdw, saveGkxf, updateJcdw, delJcdw } from '/@/api/common/api';
  import { useRouter } from 'vue-router';
  import { nextTick } from 'vue';

  let router = useRouter();
  const { createMessage } = useMessage();
  const params = ref(router.currentRoute.value.query);
  const saveFlg = ref(true);
  let unitMessageFormList = ref([{ id: null }]);
  const ssdw = ref([{ id: null }]);
  const jldw = ref([{ id: null }]);
  // 获取地块信息
  const dsInfor = ref<any>({
    jcdw: [],
    ssdw: [],
    jldw: [],
    bzdw: [],
    cbdc: {},
    xxdc: {},
    wrdkjbxxb: {},
  });

  async function getdkInfor() {
    dsInfor.value = await plotDetails({
      wrdkid: params.value.wrdkid,
      id: params.value.id,
      pgtype: params.value.pgtype,
      scjdbm: 'S4',
    });
    // 后台返回数据有点是null 有的是[]
    saveFlg.value = true;
    unitMessageFormList.value = dsInfor.value.bzdw || [{ id: null }];
    ssdw.value = dsInfor.value.ssdw || [{ id: null }];
    jldw.value = dsInfor.value.jldw || [{ id: null }];

    if (unitMessageFormList.value.length == 0) unitMessageFormList.value.push({ id: null });
    if (ssdw.value.length == 0) ssdw.value.push({ id: null });
    if (jldw.value.length == 0) jldw.value.push({ id: null });
  }
  getdkInfor();

  const handleUpSuccess = ()=>{
    // getdkInfor();
  }
  const activeKey = ref(['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '140000', '150000', '160000', '4222222']);

  // 风险管控基本方案
  const chilrenReport = ref<any>(null);
  async function saveReport(event) {
    event.stopPropagation();
    const res = await chilrenReport?.value.getFormValueReport();
    const reg = /^(http|https):\/\/(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|localhost|[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*\.[a-zA-Z]{2,})(:\d{2,5})?(\/\S*)?$/;
    if (res.gsfs == 1) {
      if (!res.gswz) {
        createMessage.warn('请填写网址');
        return;
      }
      if (!reg.test(res.gswz)) {
        createMessage.warn('请输入正确的网址');
        return false;
      }
    }
    if (new Date(res.tmStart) > new Date(res.tmEnd)) {
      createMessage.warn('风险管控工程措施开始日期不能大于风险管控工程措施结束日期');
      return;
    }
    // if (new Date(res.fbsj) > new Date(res.tmStart)) {
    //   createMessage.warn('风险管控方案编制完成日期不能大于风险管控工程措施开始日期');
    //   return;
    // }

    await saveGkxf(res);
  }
  // 风险管控措施信息
  const chilrenReportxx = ref<any>(null);
  async function saveCsxx(event) {
    event.stopPropagation();
    const res = await chilrenReportxx?.value.getFormValueGKxx();
    if (res.kzfxgktrmj > dsInfor.value.wrdkjbxxb.zdmj) {
      createMessage.warn('开展风险管控土壤面积不能超过地块占地面积');
      return false;
    }
    if (!res.gkcsQt && res.gkcs ==3) {
      createMessage.warn('请填写风险管控措施其他信息');
      return false;
    }
    if (res.gkcsQt=='阻隔' && !res.zglx) {
      createMessage.warn('请填选择阻隔类型');
      return false;
    }
    if (!res.gkcsQt && res.gkcs ==2) {
      createMessage.warn('请填其他信息或选择阻隔类型');
      return false;
    }
    dsInfor.value.gkxf = {...dsInfor.value.gkxf, ...res};
    await saveGkxf(res);
  }
  // 编制单位开始
  const childrenBzd = ref<any>([]);
  const childRef = (el, index) => {
    if (el) childrenBzd.value[index] = el;
  };
  const callChildMethod = (index) => {
    childrenBzd.value[index].getFormValueBz();
  };
  function addUnitMessageFormList(event) {
    event.stopPropagation();
    unitMessageFormList.value.push({ id: null });
    nextTick(() => {
      callChildMethod(unitMessageFormList.value.length - 1);
    });
  }
  async function delMessageFormList(event, index) {
    event.stopPropagation();
    if (unitMessageFormList.value[index].id) {
      await delBzdw({ id: unitMessageFormList.value[index].id });
    }
    unitMessageFormList.value.splice(index, 1);
    childrenBzd.value.splice(index, 1);
    // getdkInfor();
  }
  async function suBainFormAddEdit(event, index) {
    event.stopPropagation();
    try {
      const res = await childrenBzd.value[index].getFormValueBz();
      res.wthtje = String(res.wthtje);
      res.scjdbm = 'S4';
      res.pgtype = params.value.pgtype;
      // 新增的时候没有这个值
      res.wrdkid = params.value.wrdkid;
      res.jgtype = 'bzdw';
      if (saveFlg.value) {
        saveFlg.value = false;
        const id = await updateBzdw(res);
        if (id != '成功') {
          unitMessageFormList.value[index] = res;
          unitMessageFormList.value[index].id = id;
        }
        saveFlg.value = true;
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  // 编制单位结束
  // 实施单位
  const childrenss = ref<any>([]);
  const childRefss = (el, index) => {
    if (el) childrenss.value[index] = el;
  };
  const callChildMethodss = (index) => {
    childrenss.value[index].getFormValueBz();
  };
  // 新增
  function addSs(event) {
    event.stopPropagation();
    ssdw.value.push({ id: null });
    nextTick(() => {
      callChildMethodss(ssdw.value.length - 1);
    });
  }
  // 删除
  async function deless(event, index) {
    event.stopPropagation();
    if (ssdw.value[index].id) await delBzdw({ id: ssdw.value[index].id });
    ssdw.value.splice(index, 1);
    childrenss.value.splice(index, 1);
  }
  // 保存
  async function savess(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenss.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S4';
        res.pgtype = params.value.pgtype;
        res.jgtype = 'ssdw';
        res.wrdkid = params.value.wrdkid;
        const id = await updateBzdw(res);
        if (id != '成功') {
          ssdw.value[index] = res;
          ssdw.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
  //监理单位
  const childrenjl = ref<any>([]);
  const childRefjl = (el, index) => {
    if (el) childrenjl.value[index] = el;
  };
  const callChildMethodjl = (index) => {
    childrenss.value[index].getFormValueBz();
  };
  // 新增
  function addjl(event) {
    event.stopPropagation();
    jldw.value.push({ id: null });
    nextTick(() => {
      callChildMethodjl(jldw.value.length - 1);
    });
  }
  // 删除
  async function deljl(event, index) {
    event.stopPropagation();
    if (jldw.value[index].id) await delJcdw({ id: jldw.value[index].id });
    jldw.value.splice(index, 1);
    childrenjl.value.splice(index, 1);
  }
  // 保存
  async function savejl(event, index) {
    event.stopPropagation();
    try {
      if (saveFlg.value) {
        saveFlg.value = false;
        const res = await childrenjl.value[index].getFormValueBz();
        res.wthtje = String(res.wthtje);
        res.scjdbm = 'S4';
        res.pgtype = params.value.pgtype;
        res.jgtype = 'jldw';
        res.wrdkid = params.value.wrdkid;
        const id = await updateJcdw(res);
        if (id != '成功') {
          jldw.value[index] = res;
          jldw.value[index].id = id;
        }
        saveFlg.value = true;
        // getdkInfor();
      } else {
        createMessage.warn('数据更新中请稍后点击');
      }
    } catch {
      saveFlg.value = true;
    }
  }
</script>

<style lang="less" scoped>
  :deep(.ant-collapse-borderless) {
    width: 100%;
  }
</style>
